C_RED    equ    $f800
C_GREEN  equ    $07e0
C_BLUE   equ    $001f
C_WHITE  equ    $ffff
null    equ     $0
Rzero   equ     $0
A0      equ     $4
A1      equ     $5
A2      equ     $6
A3      equ     $7
T0      equ     $8
T1      equ     $9
T2      equ     $a
T3      equ     $b
T4      equ     $c
T5      equ     $d
T6      equ     $e
T7      equ     $f
S0      equ     $10

GP      equ     28              ; 0x1c General Purpose
SP      equ     29              ; Stack Pointer
RA      equ     31

Index   equ     $0                      ; Cop0 Regs
Random  equ     $1
Count   equ     $9

x        equ     T7
y        equ     T6
c        equ     T5
vx       equ     T1
vy       equ     T2

dw       arg_x
dw       arg_y
dw       arg_z
dw       arg_c
dw       arg_1
dw       arg_2
dw       arg_3
dw       arg_4

dw       ret_1
dw       ret_2
dw       ret_3
dw       ret_4

dw       store1
dw       store2
dw       store3
dw       store4

  
.SUB                                    ; Means Compile program as a Sub program (DEFAULT:.SUB)


;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
PROC     PIXEL                          ; <--- Special Defined!!
         PUSH    RA
         PUSH    A0
         PUSH    A1
         PUSH    T5
         PUSH    T6
         PUSH    T7


         MOVE    T6,arg_y
         ;nop
         MOVE    T7,arg_x
         ;nop
         MOVE    T5,arg_c
         ;nop
                  
         addiu    A0,T6,0               ; A0 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A0,A0,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A0,A0,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))
         lui     A1,$8010                ; look at N64's Data tables
         lw      A1,$0(A1)               ; store vid address in A1
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A0,A0,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A0                ; A1+=A0
         sh      T5, $0(A1)              ; BLAST THE 16-BIT VAL


         POP     T7
         POP     T6
         POP     T5
         POP     A1
         POP     A0
         POP     RA
         RETF                            ; JR           R31  (ra)
         nop
         nop

PROC    IMG_FONTNB
        PUSH    RA
        PUSH    A0
        PUSH    A1
        PUSH    A2
        PUSH    T0
        PUSH    T1
        PUSH    T2
        PUSH    T3
        PUSH    T6
        PUSH    T7

        ; --- Point to Correct image part!
        MOVEA   A0,img_dat           ; Pixels (+32)
        addiu   A0,A0,32

        MOVE    A1,arg_z             ; arg_z contains the Character
        ;addiu   A1,Rzero,99             ;; :->
        sll     A1,A1,5              ; *=5  <<=5
        add     A0,A0,A1             ; a0+=a1
        ; --- point to correct Screen offset!!
         MOVE     T6,arg_y
         ;nop
         MOVE     T7,arg_x
         ;nop
         addiu    A2,T6,0               ; A2 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A2,A2,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A2,A2,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))
         lui     A1,$8010                ; look at N64's Data tables
         lw      A1,$0(A1)               ; store vid address in A1
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A2                ; A1+=A0
                        
        ;addiu   A1, A1,6420

        ; --- point to Colours position!!!        
        ;MOVEA   A2,img_dat           ; Colours (+0)
        MOVE    A2,arg_c                ; Specific colour
        addiu   T3, Rzero,1

NextLine:             
        addiu   T2, Rzero,8             ; 8 lines
NextPix:              
        addiu   T1, Rzero,4             ; (4*2) line

        lb      T0, $0(A0)
        andi    T0, T0,$00f0
        srl     T0, T0,4
        add     T0, T0,T0

        ;addu    A3, A2,T0               ;; T0 = A2[T0]
        ;lh      T0, $0(A3)              ;; ""   ""
        beq      T0,Rzero,Black          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                 ; T0 = A2 (Colour)
;Black:
        nop
        sh      T0, $0(A1)
        nop
Black:
        nop
        addiu   A1, A1,2
        
        lb      T0, $0(A0)
        andi    T0, T0,$0f
        add     T0, T0,T0

        ;addu    A3, A2,T0
        ;lh      T0, $0(A3)
        beq      T0,Rzero,Black2          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                  ;  T0 = A2 (Colour)
;Black2:                                  
        nop
        sh      T0, $0(A1)
        nop
Black2:
        nop
        addiu   A1, A1,2

        addiu   A0, A0,1
        sub     T1, T1,T3
        bne     T1, Rzero, NextPix
        nop

        addiu   A1, A1,624                         ; (320-8)*2=624
        sub     T2, T2,T3
        bne     T2, Rzero, NextLine
        nop


        POP     T7
        POP     T6
        POP     T3
        POP     T2
        POP     T1
        POP     T0
        POP     A2
        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop




PROC    FONT
        PUSH    RA
        PUSH    A0
        PUSH    A1
        PUSH    A2
        PUSH    T0
        PUSH    T1
        PUSH    T2
        PUSH    T3
        PUSH    T6
        PUSH    T7

        ; --- Point to Correct image part!
        MOVEA   A0,img_dat           ; Pixels (+32)
        addiu   A0,A0,32

        MOVE    A1,arg_z             ; arg_z contains the Character
        sll     A1,A1,5              ; *=5  <<=5
        add     A0,A0,A1             ; a0+=a1
        ; --- point to correct Screen offset!!
         MOVE     T6,arg_y
         ;nop
         MOVE     T7,arg_x
         ;nop
         addiu    A2,T6,0               ; A2 = T6;
         addiu    A1,T6,0               ; A1 = T6   
         sll      A2,A2,9               ;  A0<<=9 512 / 256pix
         sll      A1,A1,7               ;  A0<<=7 128 / 64pix
         add      A2,A2,A1               ; A0+=A1 (A0 = (y<<8)+y<<6))
         lui     A1,$8010                ; look at N64's Data tables
         lw      A1,$0(A1)               ; store vid address in A1
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- Twice cos the
         add     A2,A2,T7                ; A0 = A0+T7 (x) <-- pixel is 16-bit
         add     A1,A1,A2                ; A1+=A0
                        
        ;addiu   A1, A1,6420

        ; --- point to Colours position!!!        
        ;MOVEA   A2,img_dat           ; Colours (+0)
        MOVE    A2,arg_c                ; Specific colour
        addiu   T3, Rzero,1

ANextLine:             
        addiu   T2, Rzero,8             ; 8 lines
ANextPix:              
        addiu   T1, Rzero,4             ; (4*2) line

        lb      T0, $0(A0)
        andi    T0, T0,$00f0
        srl     T0, T0,4
        add     T0, T0,T0

        ;addu    A3, A2,T0               ;; T0 = A2[T0]
        ;lh      T0, $0(A3)              ;; ""   ""
        beq      T0,Rzero,ABlack          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                 ; T0 = A2 (Colour)
ABlack:
        nop
        sh      T0, $0(A1)
        nop
;ABlack:
        nop
        addiu   A1, A1,2
        
        lb      T0, $0(A0)
        andi    T0, T0,$0f
        add     T0, T0,T0

        ;addu    A3, A2,T0
        ;lh      T0, $0(A3)
        beq      T0,Rzero,ABlack2          ;; Naturally Black is drawn!!
        nop
        addiu    T0,A2,0                  ;  T0 = A2 (Colour)
ABlack2:                                  
        nop
        sh      T0, $0(A1)
        nop
;ABlack2:
        nop
        addiu   A1, A1,2

        addiu   A0, A0,1
        sub     T1, T1,T3
        bne     T1, Rzero, ANextPix
        nop

        addiu   A1, A1,624                         ; (320-8)*2=624
        sub     T2, T2,T3
        bne     T2, Rzero, ANextLine
        nop


        POP     T7
        POP     T6
        POP     T3
        POP     T2
        POP     T1
        POP     T0
        POP     A2
        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop







PROC    NUM_FONT
        PUSH    RA
        PUSH    A0
        PUSH    A1
        PUSH    A2

        MOVE    A1,arg_z                ; Get  # for quick access & prevent damaging it!
        andi    A1,A1,$ff               ; Eradicate upperbits

        ; 3rdS.F

        addiu   A0,A1,0
        srl     A0,A0,4
        addiu   A0,A0,$30               ; CHR$(3 + 48) = '3'
        addiu   A2,Rzero,58             
        sub     A0,A0,A2
        bltz    A0,doit3
        nop
        addiu   A0,A0,7
doit3:
        nop
        addiu   A0,A0,58
        MOVE    arg_z,A0
        nop
        CALL    FONT
        nop
        ; 4thS.F

        addiu   A0,A1,0
        andi    A0,A0,$0f               ; A0 = 0x35 & 0x0f = 0x05
        addiu   A0,A0,$30               ; CHR$(5 + 48) = '5'
        addiu   A2,Rzero,58             
        sub     A0,A0,A2
        bltz    A0,doit4
        nop
        addiu   A0,A0,7
doit4:
        nop
        addiu   A0,A0,58
        MOVE    arg_z,A0
        MOVE    A0,arg_x                ; Get X position

        addiu   A0,A0,8                 ; X+=8 (For next char pos)
        MOVE    arg_x,A0

        CALL    FONT
        nop

        addiu   A0,A0,8
        MOVE    arg_x,A0                ; So it's automatickidoly stored

        POP     A2
        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND
        PUSH    RA
        PUSH    A0

        mfc0    A0,Random               ;; Get Random Value!!!!!!!!
        MOVE    ret_1,A0                ;; Return Value in ret_1

        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND256
        PUSH    RA
        PUSH    A0
        PUSH    A1

        mfc0    A0,Random               ;; Get Random Value #1 0 - 31
        mfc0    A1,Random               ;; Get Random Value #2 0 - 31
        sll     A1,A1,5                 ;; multiply by 32
        add     A0,A0,A1                ;; A0 = A0+A1           gives 0 - 1023
        andi    A0,A0,$ff               ;; make value range between 0-255
        MOVE    ret_1,A0                ;; Return Value in ret_1

        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND128
        PUSH    RA
        PUSH    A0

        CALL    GET_RAND256
        MOVE    A0,ret_1                ;; bug
        andi    A0,A0,$7f               ;; 0 - 127
        MOVE    ret_1,A0                

        POP     A0
        POP     RA
        RETF
        nop
        nop

PROC    GET_RAND64k
        PUSH    RA
        PUSH    A0
        PUSH    A1

        CALL    GET_RAND256                     ;; Get High order
        MOVE    A0,ret_1                ;; bug
        sll     A0,A0,8
        CALL    GET_RAND256                     ;; Get Low order
        MOVE    A1,ret_1                ;; bug
        add     A0,A0,A1                ;; A0+=A1
        MOVE    ret_1,A0

        POP     A1
        POP     A0
        POP     RA
        RETF
        nop
        nop


.tag  "img_dat"
.file "font.dat"
.byte "<-End->"
